package cz.cuni.amis.pogamut.ut2004.lectures.tagbot;

import cz.cuni.amis.pogamut.base.communication.worldview.listener.annotation.EventListener;
import cz.cuni.amis.pogamut.base.utils.guice.AgentScoped;
import cz.cuni.amis.pogamut.base3d.worldview.object.Location;
import cz.cuni.amis.pogamut.ut2004.agent.module.sensor.Players;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbcommands.Initialize;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbcommands.SendMessage;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.*;
import cz.cuni.amis.pogamut.ut2004.lectures.tagbot.TagMap.Direction;
import cz.cuni.amis.pogamut.ut2004.tag.bot.UT2004BotTagController;
import cz.cuni.amis.pogamut.ut2004.utils.UT2004BotRunner;
import cz.cuni.amis.utils.exception.PogamutException;
import java.util.Random;

/**
 * Simple bot that is meant to be used together with 'DM-TagMap'. It serves for the testing of {@link TagMap}. 
 * <p><p>
 * There is a 'map' directory containing 'DM-TagMap.ut2' that should be placed into 'UT2004/Maps' directory.
 * The map is simple "rectangle" with no internal walls / obstacles. Simple "rectangle" arena.
 * <p><p>
 * By observing the logs, you can estimate how fast the agent can run at 100% and some other constants
 * concerning running.
 *
 * @author Jakub Gemrot aka Jimmy
 */
 



@AgentScoped
public class RunAroundTagMapBot extends UT2004BotTagController {
 //   Players
        static int counterId = 0;
        static int Ready = 0;
        static int Ready2 =2;
        int myId = 0;
	Location wishedLocation=null;
        Direction running = Direction.NORTH; 
	
	@Override
    public Initialize getInitializeCommand() {
        return new Initialize().setName("RunAroundTagMapBot");
    }

    @SuppressWarnings("unchecked")
    @Override
    public void botInitialized(GameInfo gameInfo, ConfigChange config, InitedMessage init) {
    	myId = counterId++; 
        info.getBotName().setInfo(running.name());
        
           switch(myId){
             case 0:
                 wishedLocation = new Location(400, 200, 48); 
                 this.getName().setNameBase("BOT 0");
                 Ready++;
                 break;
             case 1:
                 wishedLocation = new Location(400, 600, 48);
                 this.getName().setNameBase("BOT 1");
                 Ready++;
                 break;
 
         }
        
        
    }
    String myState = "look";
    int myCounter = 0;
    int gCounter =0;
    Location myLocation = null;
    
    //GenBotVect gbv = new GenBotVect();
    //------------------------LOGIC------------------------------------
    @Override
    public void logic() {
        
        while (gCounter > 0) { gCounter--; return; }
        
        if (myState.equals("stop")){
            return;
            
        }
        
        if (myState.equals("center")){
            move.moveTo(new Location(2500,1350,0));
            return;
        
        }
        
        if (myState.equals("look")){
           if (gCounter > 5) {gCounter = 5;}
                move.turnHorizontal(90);     
        }
        
        
        // RIDIM OTEVIRACI PROMENNOU
        if (myId == 0){gCounter--;}
        
        if (gCounter <= 0){
            gCounter = 20;
           
            myLocation =info.getLocation();
        }
        
        
        
         if (myState.equals("catch")){  /// ZDE UDELAM CHYTANI
        
           Player nearestPlayer = players.getNearestPlayer(10000);
            if (nearestPlayer != null && nearestPlayer.getLocation() != null){
                try {
                    
                    Location vect = genCatchVect(nearestPlayer.getLocation(),info.getLocation());
                    Location wantGo = Location.add(info.getLocation(),vect);
                    // move.moveTo(wantGo);
                    move.strafeTo(wantGo, nearestPlayer);
                    log.info("actPosition:" + info.getLocation() );
                    log.info("answVect:"+ vect.toString());
                    log.info("wannaGo:" + wantGo );
                    log.info("Distance " + 
                            Double.toString(Location.getDistance(nearestPlayer.getLocation(), info.getLocation()))
                            );
                } catch (Exception e) {
                log.info(e.toString());
                }

            }
        
        
        
        }
        

        
      
      
        if (myState.equals("run")){
        
        // info.getNearestVisiblePlayer();
        // if (gCounter != 19) { return;} 
            Player nearestPlayer = players.getNearestPlayer(10000);
            if (nearestPlayer != null && nearestPlayer.getLocation() != null){
                try {
                    Location vect = genRunVect(nearestPlayer.getLocation(), info.getLocation());
                    Location wantGo = Location.add(vect,info.getLocation());
                // move.moveTo(wantGo);
                    move.strafeTo(wantGo, nearestPlayer);
                    log.info("actPosition:" + info.getLocation() );
                    log.info("answVect:"+ vect.toString());
                    log.info("wannaGo:" + wantGo );

                } catch (Exception e) {
                log.info(e.toString());
                }

            }

        }
    
    }
        
    @EventListener(eventClass = GlobalChat.class)
    public void chat(GlobalChat event) {
        
        if (event.getText().contains("hi")) {
            act.act(new SendMessage().setText("hi").setGlobal(true));
        }
        
        if (event.getText().contains("state")){
            String str = event.getText();
            String state = str.substring(str.indexOf(" ")+1);

            myState = state;
        }
        
        if (event.getText().contains("Start following")) {
           // followTarget = event.getId();
        }
        if (event.getText().contains("Stop following")) {
           // followTarget = null;
        }
    }

    public static void main(String args[]) throws PogamutException {
    	// START 3 AGENTS FIRST
       // new UT2004BotRunner(RunAroundTagMapBot.class, "RunAround").setMain(false).startAgent();        
        new UT2004BotRunner(RunAroundTagMapBot.class, "RunAround").setMain(true).startAgent();
    }
    
    
    
      Location genCatchVect(Location catcher, Location victim ) throws Exception{
    
        if (catcher == null || victim == null) {
            throw new Exception("NULL POINTER in genRunVect!!!");
        }

        Location answ = new Location(0, 0);
        double vahaConst  = 400;
        double velikostVektoru = 100;
         
        //Vektor catchera
        Location vectFromBot = Location.add(catcher, victim.invert()).getNormalized().scale(500);
        
        
        double distance = 0;
        double vaha = 0;
       
        answ = Location.add(answ, vectFromBot);       
  
        // vektor zdi EAST
        distance = TagMap.getWallDistance(Direction.EAST, victim);
        vaha = vahaConst/distance;
        answ = Location.add(answ,new Location(-velikostVektoru,0,0).scale(vaha));
        
        // vektor zdi North
        distance =  TagMap.getWallDistance(Direction.NORTH, victim);
        vaha = vahaConst/distance;
        answ = Location.add(answ,new Location(0,velikostVektoru,0).scale(vaha));
  
        // vektor zdi South
        distance = TagMap.getWallDistance(Direction.SOUTH, victim);
        vaha = vahaConst/distance;
      
        answ = Location.add(answ,new Location(0,-velikostVektoru,0).scale(vaha));
        
        // vektor zdi West
        distance = TagMap.getWallDistance(Direction.WEST, victim);
        vaha = vahaConst/distance;
        answ = Location.add(answ,new Location(velikostVektoru,0,0).scale(vaha));
        
        return answ;
     
  
    }
    
    
    
    
    
    
    
    
      Location genRunVect(Location tagBot, Location botPosition ) throws Exception{
    
        if (tagBot == null || botPosition == null) {
            throw new Exception("NULL POINTER in genRunVect!!!");
        }
        
               
        Location answ = new Location(0, 0);
        double vahaConst  = 400;
        double vahaConstZdi = 400;
        double velikostVektoru = 100;
        double sumaVah = 0;

         
         
        //Vektor tagbota 
        Location vectFromBot = Location.add(botPosition, tagBot.invert()).getNormalized().scale(100);
        
        double distance = Location.getDistance(botPosition, tagBot);
        double vaha = vahaConst/distance;
        sumaVah += vaha;
        
        answ = Location.add(answ, vectFromBot.scale(vaha));       
        
        // vektor zdi EAST
        distance = TagMap.getWallDistance(Direction.EAST, botPosition);
        vaha = vahaConstZdi/distance;
        sumaVah += vaha;
        answ = Location.add(answ,new Location(-velikostVektoru,0,0).scale(vaha));
              
        // vektor zdi North
        distance =  TagMap.getWallDistance(Direction.NORTH, botPosition);
        vaha = vahaConstZdi/distance;
        sumaVah += vaha;
        answ = Location.add(answ,new Location(0,velikostVektoru,0).scale(vaha));
   
           
        // vektor zdi South
        distance = TagMap.getWallDistance(Direction.SOUTH, botPosition);
        vaha = vahaConstZdi/distance;
        sumaVah += vaha;
        answ = Location.add(answ,new Location(0,-velikostVektoru,0).scale(vaha));
        
        
        // vektor zdi West
        distance = TagMap.getWallDistance(Direction.WEST, botPosition);
        vaha = vahaConstZdi/distance;
        sumaVah += vaha;
        answ = Location.add(answ,new Location(velikostVektoru,0,0).scale(vaha));
        
        sumaVah = sumaVah/5*velikostVektoru;
        double silaVektoru = Math.abs(answ.getX())+  Math.abs(answ.getY());
        
        if (silaVektoru * 2 >  sumaVah){
            answ.scale(500);
        }
        
        return answ;
        
   
    }
    
      
      void look(){
        gCounter = 5;
        move.turnHorizontal(90);     
          
      }
      
    
    
}
